// Code generated by protoc-gen-connect-go. DO NOT EDIT.
//
// Source: connectrpc/rooms/v1/events.proto

package roomsv1connect

import (
	connect "connectrpc.com/connect"
	context "context"
	errors "errors"
	v1 "gitlab.com/binarygame/microservices/rooms/pkg/gen/connectrpc/rooms/v1"
	http "net/http"
	strings "strings"
)

// This is a compile-time assertion to ensure that this generated file and the connect package are
// compatible. If you get a compiler error that this constant is not defined, this code was
// generated with a version of connect newer than the one compiled into your binary. You can fix the
// problem by either regenerating this code with an older version of connect or updating the connect
// version compiled into your binary.
const _ = connect.IsAtLeastVersion1_13_0

const (
	// EventServiceName is the fully-qualified name of the EventService service.
	EventServiceName = "connectrpc.rooms.v1.EventService"
)

// These constants are the fully-qualified names of the RPCs defined in this package. They're
// exposed at runtime as Spec.Procedure and as the final two segments of the HTTP route.
//
// Note that these are different from the fully-qualified method names used by
// google.golang.org/protobuf/reflect/protoreflect. To convert from these constants to
// reflection-formatted method names, remove the leading slash and convert the remaining slash to a
// period.
const (
	// EventServiceSubscribeRoomEventsProcedure is the fully-qualified name of the EventService's
	// SubscribeRoomEvents RPC.
	EventServiceSubscribeRoomEventsProcedure = "/connectrpc.rooms.v1.EventService/SubscribeRoomEvents"
	// EventServiceSubscribeAllRoomEventsProcedure is the fully-qualified name of the EventService's
	// SubscribeAllRoomEvents RPC.
	EventServiceSubscribeAllRoomEventsProcedure = "/connectrpc.rooms.v1.EventService/SubscribeAllRoomEvents"
)

// These variables are the protoreflect.Descriptor objects for the RPCs defined in this package.
var (
	eventServiceServiceDescriptor                      = v1.File_connectrpc_rooms_v1_events_proto.Services().ByName("EventService")
	eventServiceSubscribeRoomEventsMethodDescriptor    = eventServiceServiceDescriptor.Methods().ByName("SubscribeRoomEvents")
	eventServiceSubscribeAllRoomEventsMethodDescriptor = eventServiceServiceDescriptor.Methods().ByName("SubscribeAllRoomEvents")
)

// EventServiceClient is a client for the connectrpc.rooms.v1.EventService service.
type EventServiceClient interface {
	// RPC to get a stream of RoomEvents based on the roomId
	SubscribeRoomEvents(context.Context, *connect.Request[v1.SubscribeRoomEventsRequest]) (*connect.ServerStreamForClient[v1.SubscribeRoomEventsResponse], error)
	// RPC to get a stream of RoomEvents of all rooms
	SubscribeAllRoomEvents(context.Context, *connect.Request[v1.SubscribeAllRoomEventsRequest]) (*connect.ServerStreamForClient[v1.SubscribeAllRoomEventsResponse], error)
}

// NewEventServiceClient constructs a client for the connectrpc.rooms.v1.EventService service. By
// default, it uses the Connect protocol with the binary Protobuf Codec, asks for gzipped responses,
// and sends uncompressed requests. To use the gRPC or gRPC-Web protocols, supply the
// connect.WithGRPC() or connect.WithGRPCWeb() options.
//
// The URL supplied here should be the base URL for the Connect or gRPC server (for example,
// http://api.acme.com or https://acme.com/grpc).
func NewEventServiceClient(httpClient connect.HTTPClient, baseURL string, opts ...connect.ClientOption) EventServiceClient {
	baseURL = strings.TrimRight(baseURL, "/")
	return &eventServiceClient{
		subscribeRoomEvents: connect.NewClient[v1.SubscribeRoomEventsRequest, v1.SubscribeRoomEventsResponse](
			httpClient,
			baseURL+EventServiceSubscribeRoomEventsProcedure,
			connect.WithSchema(eventServiceSubscribeRoomEventsMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		subscribeAllRoomEvents: connect.NewClient[v1.SubscribeAllRoomEventsRequest, v1.SubscribeAllRoomEventsResponse](
			httpClient,
			baseURL+EventServiceSubscribeAllRoomEventsProcedure,
			connect.WithSchema(eventServiceSubscribeAllRoomEventsMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
	}
}

// eventServiceClient implements EventServiceClient.
type eventServiceClient struct {
	subscribeRoomEvents    *connect.Client[v1.SubscribeRoomEventsRequest, v1.SubscribeRoomEventsResponse]
	subscribeAllRoomEvents *connect.Client[v1.SubscribeAllRoomEventsRequest, v1.SubscribeAllRoomEventsResponse]
}

// SubscribeRoomEvents calls connectrpc.rooms.v1.EventService.SubscribeRoomEvents.
func (c *eventServiceClient) SubscribeRoomEvents(ctx context.Context, req *connect.Request[v1.SubscribeRoomEventsRequest]) (*connect.ServerStreamForClient[v1.SubscribeRoomEventsResponse], error) {
	return c.subscribeRoomEvents.CallServerStream(ctx, req)
}

// SubscribeAllRoomEvents calls connectrpc.rooms.v1.EventService.SubscribeAllRoomEvents.
func (c *eventServiceClient) SubscribeAllRoomEvents(ctx context.Context, req *connect.Request[v1.SubscribeAllRoomEventsRequest]) (*connect.ServerStreamForClient[v1.SubscribeAllRoomEventsResponse], error) {
	return c.subscribeAllRoomEvents.CallServerStream(ctx, req)
}

// EventServiceHandler is an implementation of the connectrpc.rooms.v1.EventService service.
type EventServiceHandler interface {
	// RPC to get a stream of RoomEvents based on the roomId
	SubscribeRoomEvents(context.Context, *connect.Request[v1.SubscribeRoomEventsRequest], *connect.ServerStream[v1.SubscribeRoomEventsResponse]) error
	// RPC to get a stream of RoomEvents of all rooms
	SubscribeAllRoomEvents(context.Context, *connect.Request[v1.SubscribeAllRoomEventsRequest], *connect.ServerStream[v1.SubscribeAllRoomEventsResponse]) error
}

// NewEventServiceHandler builds an HTTP handler from the service implementation. It returns the
// path on which to mount the handler and the handler itself.
//
// By default, handlers support the Connect, gRPC, and gRPC-Web protocols with the binary Protobuf
// and JSON codecs. They also support gzip compression.
func NewEventServiceHandler(svc EventServiceHandler, opts ...connect.HandlerOption) (string, http.Handler) {
	eventServiceSubscribeRoomEventsHandler := connect.NewServerStreamHandler(
		EventServiceSubscribeRoomEventsProcedure,
		svc.SubscribeRoomEvents,
		connect.WithSchema(eventServiceSubscribeRoomEventsMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	eventServiceSubscribeAllRoomEventsHandler := connect.NewServerStreamHandler(
		EventServiceSubscribeAllRoomEventsProcedure,
		svc.SubscribeAllRoomEvents,
		connect.WithSchema(eventServiceSubscribeAllRoomEventsMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	return "/connectrpc.rooms.v1.EventService/", http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		switch r.URL.Path {
		case EventServiceSubscribeRoomEventsProcedure:
			eventServiceSubscribeRoomEventsHandler.ServeHTTP(w, r)
		case EventServiceSubscribeAllRoomEventsProcedure:
			eventServiceSubscribeAllRoomEventsHandler.ServeHTTP(w, r)
		default:
			http.NotFound(w, r)
		}
	})
}

// UnimplementedEventServiceHandler returns CodeUnimplemented from all methods.
type UnimplementedEventServiceHandler struct{}

func (UnimplementedEventServiceHandler) SubscribeRoomEvents(context.Context, *connect.Request[v1.SubscribeRoomEventsRequest], *connect.ServerStream[v1.SubscribeRoomEventsResponse]) error {
	return connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.EventService.SubscribeRoomEvents is not implemented"))
}

func (UnimplementedEventServiceHandler) SubscribeAllRoomEvents(context.Context, *connect.Request[v1.SubscribeAllRoomEventsRequest], *connect.ServerStream[v1.SubscribeAllRoomEventsResponse]) error {
	return connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.EventService.SubscribeAllRoomEvents is not implemented"))
}
